import { ICustomElementViewModel } from 'aurelia';

/**
 * CodeMirror
 */
declare class CodeMirror implements ICustomElementViewModel {
    private readonly _element;
    private _codeMirror?;
    codeArea: HTMLDivElement;
    /** Code */
    code?: string;
    language: string;
    theme: string;
    suggestions: Array<{
        term: string | RegExp;
        values: string[];
    }>;
    readOnly: boolean;
    lineNumbers: boolean;
    autofocus: boolean;
    private _boundedChange?;
    private _boundedFocus?;
    constructor(_element: HTMLElement);
    attached(): void | Promise<void>;
    codeChanged(newValue: string, oldValue: string): void;
    /** Set the cursor at the end of existing content */
    private _setCursorAtEnd;
    private _hintFunction;
    detaching(): void | Promise<void>;
}

export { CodeMirror };
